﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Threading;

namespace DetectCPUCoreCount
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnMeasure_Click(object sender, RoutedEventArgs e)
        {
            listData.Items.Clear();
            //listData.Items.Add(String.Format("Core count: {0}", PerformanceMeasure.GetCoreCount()));
            //int coreCount = PerformanceMeasure.GetCoreCount();

            Thread thread = new Thread(MeasureThread);
            thread.Start();
        }

        delegate void PrintOut(string s);
        private void MeasureThread()
        {
            long COUNT_OF_OPERATIONS;
            double msecElapsed;
            COUNT_OF_OPERATIONS = PerformanceMeasure.GetAverageOperations(1, PerformanceMeasure.MSEC_PER_CYCLE);
            // get correct count of operations: work around for slowdowns on startup or other (lightweight) apps running in the background
            while (PerformanceMeasure.GetAbsoluteTimeToCompute(1, COUNT_OF_OPERATIONS) < PerformanceMeasure.MSEC_ACCEPTABLE_THRESHOLD)
            {
                COUNT_OF_OPERATIONS = PerformanceMeasure.GetAverageOperations(1, PerformanceMeasure.MSEC_PER_CYCLE);
            }
            int[] coresToDetect = { 1, 2, 4, 8, 16, 32 };
            bool first = true;
            double prevValue = 0;
            int coreCount = 2;
            int prevI = 2;
            foreach (int i in coresToDetect)
            {
                msecElapsed = PerformanceMeasure.GetAbsoluteTimeToCompute(i, COUNT_OF_OPERATIONS);
                if (!first)
                {
                    if (((msecElapsed / prevValue) > PerformanceMeasure.SLOWDOWN_THRESHOLD_MULTIPLIER) && (msecElapsed >= PerformanceMeasure.MSEC_ACCEPTABLE_THRESHOLD))
                    {
                        coreCount = prevI;
                        Dispatcher.BeginInvoke(new PrintOut(
                            (s) =>
                            {
                                listData.Items.Add(s);
                            }), String.Format("{0} threads: {1:0.00}", i, msecElapsed));
                        break;
                    }
                }
                prevValue = msecElapsed;
                prevI = i;
                first = false;
                Dispatcher.BeginInvoke(new PrintOut(
                    (s) =>
                    {
                        listData.Items.Add(s);
                    }), String.Format("{0} threads: {1:0.00}", i, msecElapsed));
            }

            Dispatcher.BeginInvoke(new PrintOut(
                (s) =>
                {
                    listData.Items.Add(s);
                }), String.Format("Detected cores: {0}", coreCount));
        }
    }
}
